﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ProductAndServiceFactories
{
    class Program
    {
        static void Main(string[] args)
        {
            /***** P R O D U C T  F A C T O R Y   E X A M P L E ******/
            // Create an instance of the concrete factory – this is the only concrete class that the client needs to know about.
            // Everything else needed by the client remains abstract
            AbstractProductFactory absProdFactory = new ConcreteProductFactory();
            AbstractProduct absProductA;
            AbstractProduct absProductB;

            absProductA = absProdFactory.CreateProductA();
            absProductB = absProdFactory.CreateProductB();

            string pA1 = absProductA.ProductProperty1();
            string pA2 = absProductA.ProductProperty2();

            string pB1 = absProductB.ProductProperty1();
            string pB2 = absProductB.ProductProperty2();

            StringBuilder sb = new StringBuilder("*** START  PRODUCT FACTORY EXAMPLE ***" + System.Environment.NewLine);
            sb.Append(pA1 + System.Environment.NewLine); sb.Append(pA2 + System.Environment.NewLine); sb.Append(pB1 + System.Environment.NewLine); sb.Append(pB2 + System.Environment.NewLine);
            sb.Append("*** E N D  PRODUCT FACTORY EXAMPLE ***" + System.Environment.NewLine);

            
            /***** S E R V I C E  F A C T O R Y   E X A M P L E ******/
            // Create an instance of the concrete factory – this is the only concrete class that the client needs to know about.
            // Everything else needed by the client remains abstract
            AbstractServiceFactory absFactory = new ConcreteServiceFactory();
            AbstractService absServiceA;
            AbstractService absServiceB;

            absServiceA = absFactory.CreateServiceA();
            absServiceB = absFactory.CreateServiceB();

            string sA1 = absServiceA.serviceOperation1();
            string sA2 = absServiceA.serviceOperation2();

            string sB1 = absServiceB.serviceOperation1();
            string sB2 = absServiceB.serviceOperation2();

            sb.Append( System.Environment.NewLine + "*** START SERVICE FACTORY EXAMPLE ***" + System.Environment.NewLine);
            sb.Append(sA1 + System.Environment.NewLine);
            sb.Append(sA2 + System.Environment.NewLine); sb.Append(sB1 + System.Environment.NewLine); sb.Append(sB2 + System.Environment.NewLine);
            sb.Append("*** END  SERVICE FACTORY EXAMPLE ***" + System.Environment.NewLine);
            
            Console.Write(sb.ToString());

        }
    }
}
